diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockChestPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockChestPainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
index af52439bc..208df8912 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockChestPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
@@ -10,10 +10,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockChestPainted extends BlockChest implements IPainted {
+public class BlockLogicChestPainted extends BlockLogicChest implements IPainted {
 
-	protected BlockChestPainted(String key, String namespaceId, int id, Material material) {
-		super(key, namespaceId, id, material);
+	protected BlockLogicChestPainted(Block<?> block, Material material) {
+		super(block, material);
 	}
 	
 	@Override
@@ -24,7 +24,7 @@ public class BlockChestPainted extends BlockChest implements IPainted {
 	@Override
 	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
 	{
-		return new ItemStack[] { new ItemStack(this, 1, meta & colorBits) };
+		return new ItemStack[] { new ItemStack(block, 1, meta & colorBits) };
 	}
 
 	public static int getMetaForDyeColor(int i) {
@@ -52,7 +52,7 @@ public class BlockChestPainted extends BlockChest implements IPainted {
 	@Override
 	public void removeDye(World world, int x, int y, int z) {
 		final int meta = stripColorFromMetadata(world.getBlockMetadata(x, y, z));
-		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.CHEST_PLANKS_OAK.id, meta);
+		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.CHEST_PLANKS_OAK.id(), meta);
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockClay.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicClay.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockClay.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicClay.java
index 08450fcd8..80fdf5a54 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockClay.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicClay.java
@@ -7,11 +7,11 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockClay extends Block
+public class BlockLogicClay extends BlockLogic
 {
-    public BlockClay(String key, String namespaceId, int id)
+    public BlockLogicClay(Block<?> block)
     {
-        super(key, namespaceId, id, Material.clay);
+        super(block, Material.clay);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCobble.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobble.java
similarity index 71%
rename from game/core/src/main/java/net/minecraft/core/block/BlockCobble.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicCobble.java
index 1120b9f60..11fed0797 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockCobble.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobble.java
@@ -6,13 +6,14 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.function.Supplier;
 
-public class BlockCobble extends Block{
-    private final Supplier<IItemConvertible> crushDrop;
-    public BlockCobble(String translationKey, String namespaceId, int id, Material material, Supplier<IItemConvertible> crushResult) {
-        super(translationKey, namespaceId, id, material);
+public class BlockLogicCobble extends BlockLogic {
+    private final @Nullable Supplier<IItemConvertible> crushDrop;
+    public BlockLogicCobble(Block<?> block, Material material, @Nullable Supplier<IItemConvertible> crushResult) {
+        super(block, material);
         this.crushDrop = crushResult;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCobweb.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockCobweb.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
index 011cb9eb7..d005361f8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockCobweb.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
@@ -10,12 +10,12 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockCobweb extends Block
+public class BlockLogicCobweb extends BlockLogic
 {
 
-    public BlockCobweb(String key, String namespaceId, int id, Material mat)
+    public BlockLogicCobweb(Block<?> block, Material mat)
     {
-        super(key, namespaceId, id, mat);
+        super(block, mat);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
index ce9e4d09d..78efd1aad 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
@@ -14,10 +14,10 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockCropsPumpkin
-    extends BlockFlower implements IBonemealable {
-    public BlockCropsPumpkin(String key, String namespaceId, int id) {
-        super(key, namespaceId, id);
+public class BlockLogicCropsPumpkin
+    extends BlockLogicFlower implements IBonemealable {
+    public BlockLogicCropsPumpkin(Block<?> block) {
+        super(block);
     }
 
     @Override
@@ -42,7 +42,7 @@ public class BlockCropsPumpkin
 
     @Override
     protected boolean mayPlaceOn(int blockId) {
-        return blockId == Blocks.FARMLAND_DIRT.id;
+        return blockId == Blocks.FARMLAND_DIRT.id();
     }
 
     @Override
@@ -55,7 +55,7 @@ public class BlockCropsPumpkin
                 if (rand.nextInt((int) (100F / f)) == 0) {
                     meta++;
                     if (meta == 5) {
-                        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PUMPKIN.id, 0);
+                        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PUMPKIN.id(), 0);
                     } else {
                         world.setBlockMetadataWithNotify(x, y, z, meta);
                     }
@@ -65,7 +65,7 @@ public class BlockCropsPumpkin
     }
 
     public void fertilize(World world, int x, int y, int z) {
-        world.setBlockWithNotify(x, y, z, Blocks.PUMPKIN.id);
+        world.setBlockWithNotify(x, y, z, Blocks.PUMPKIN.id());
     }
 
     private float getGrowthRate(World world, int x, int y, int z) {
@@ -85,7 +85,7 @@ public class BlockCropsPumpkin
             for(int dz = z - 1; dz <= z + 1; dz++) {
                 int id = world.getBlockId(dx, y - 1, dz);
                 float growthRateMod = 0.0F;
-                if(id == Blocks.FARMLAND_DIRT.id) {
+                if(id == Blocks.FARMLAND_DIRT.id()) {
                     growthRateMod = 1.0F;
                     if(world.getBlockMetadata(dx, y - 1, dz) > 0) {
                         growthRateMod = 3F;
@@ -99,7 +99,7 @@ public class BlockCropsPumpkin
 
         }
 
-        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
         if (!isFertilized) {
             if (world.getSeasonManager().getCurrentSeason() != null)
             {
@@ -130,7 +130,7 @@ public class BlockCropsPumpkin
         {
             if (!world.isClientSide)
             {
-                ((BlockCropsPumpkin)Blocks.CROPS_PUMPKIN).fertilize(world, blockX, blockY, blockZ);
+                fertilize(world, blockX, blockY, blockZ);
                 if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCropsWheat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
index f0672224f..da7516505 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
@@ -13,14 +13,14 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockCropsWheat extends BlockFlower implements IBonemealable
+public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemealable
 {
     public static final int MASK_GROWTH = 0b0000_0111;
     public static final int MAX_GROWTH_STATE = 7;
-	public BlockCropsWheat(String key, String namespaceId, int id)
+	public BlockLogicCropsWheat(Block<?> block)
     {
-        super(key, namespaceId, id);
-        setTicking(true);
+        super(block);
+        block.setTicking(true);
         float f = 0.5F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.25F, 0.5F + f);
     }
@@ -28,7 +28,7 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
 	@Override
 	public boolean mayPlaceOn(int blockId)
     {
-        return blockId == Blocks.FARMLAND_DIRT.id;
+        return blockId == Blocks.FARMLAND_DIRT.id();
     }
 
     @Override
@@ -66,16 +66,16 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
         int idPosXNegZ = world.getBlockId(x + 1, y, z - 1);
         int idPosXPosZ = world.getBlockId(x + 1, y, z + 1);
         int idNegXPosZ = world.getBlockId(x - 1, y, z + 1);
-        boolean xNeighbor = idNegX == id || idPosX == id;
-        boolean zNeighbor = idNegZ == id || idPosZ == id;
-        boolean diagNeighbor = idNegXNegZ == id || idPosXNegZ == id || idPosXPosZ == id || idNegXPosZ == id;
+        boolean xNeighbor = idNegX == block.id() || idPosX == block.id();
+        boolean zNeighbor = idNegZ == block.id() || idPosZ == block.id();
+        boolean diagNeighbor = idNegXNegZ == block.id() || idPosXNegZ == block.id() || idPosXPosZ == block.id() || idNegXPosZ == block.id();
         for(int dx = x - 1; dx <= x + 1; dx++)
         {
             for(int dz = z - 1; dz <= z + 1; dz++)
             {
                 int id = world.getBlockId(dx, y - 1, dz);
                 float growthRateMod = 0.0F;
-                if(id == Blocks.FARMLAND_DIRT.id)
+                if(id == Blocks.FARMLAND_DIRT.id())
                 {
                     growthRateMod = 1.0F;
                     if(world.getBlockMetadata(dx, y - 1, dz) > 0)
@@ -96,7 +96,7 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
             growthRate /= 2.0F;
         }
 
-        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
         if (!isFertilized) {
             if (world.getSeasonManager().getCurrentSeason() != null)
             {
@@ -110,11 +110,11 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
 
     @Override
     public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
-        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
         if (isFertilized && !world.isClientSide) {
             boolean shouldDefertilize = world.rand.nextInt(3) == 2;
             if (shouldDefertilize) {
-                world.setBlockMetadata(x, y - 1, z, BlockFarmland.setFertilized(world.getBlockMetadata(x, y - 1, z), false));
+                world.setBlockMetadata(x, y - 1, z, BlockLogicFarmland.setFertilized(world.getBlockMetadata(x, y - 1, z), false));
             }
         }
     }
@@ -138,7 +138,7 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
         {
             if(!world.isClientSide)
             {
-                ((BlockCropsWheat)Blocks.CROPS_WHEAT).fertilize(world, blockX, blockY, blockZ);
+                fertilize(world, blockX, blockY, blockZ);
                 if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockDeadBush.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDeadBush.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockDeadBush.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicDeadBush.java
index acc5e698b..885ac09e7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockDeadBush.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDeadBush.java
@@ -6,12 +6,12 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockDeadBush extends BlockFlower
+public class BlockLogicDeadBush extends BlockLogicFlower
 {
 
-	public BlockDeadBush(String key, String namespaceId, int id)
+	public BlockLogicDeadBush(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
     }
@@ -19,7 +19,7 @@ public class BlockDeadBush extends BlockFlower
     @Override
 	public boolean mayPlaceOn(int blockId)
     {
-        return blockId == Blocks.SAND.id || blockId == Blocks.DIRT_SCORCHED.id;
+        return blockId == Blocks.SAND.id() || blockId == Blocks.DIRT_SCORCHED.id();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockDispenser.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index cbac228c2..da7d5665b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -2,7 +2,6 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.player.Player;
@@ -16,12 +15,13 @@ import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-public class BlockDispenser extends BlockTileEntityVeryRotatable
+public class BlockLogicDispenser extends BlockLogicVeryRotatable
 {
     public static final int MASK_POWERED = 0b0000_1000;
-	public BlockDispenser(String key, String namespaceId, int id)
+	public BlockLogicDispenser(Block<?> block)
     {
-        super(key, namespaceId, id, Material.stone);
+        super(block, Material.stone);
+        block.withEntity(TileEntityDispenser::new);
     }
 
     @Override
@@ -46,7 +46,7 @@ public class BlockDispenser extends BlockTileEntityVeryRotatable
 
     private void dispenseItem(World world, int x, int y, int z, Random random)
     {
-        Direction direction = BlockTileEntityVeryRotatable.metaToDirection(world.getBlockMetadata(x, y, z));
+        Direction direction = BlockLogicVeryRotatable.metaToDirection(world.getBlockMetadata(x, y, z));
         int xOffset = direction.getOffsetX();
         int yOffset = direction.getOffsetY();
         int zOffset = direction.getOffsetZ();
@@ -108,7 +108,7 @@ public class BlockDispenser extends BlockTileEntityVeryRotatable
         int meta = world.getBlockMetadata(x, y, z);
         if(flag && (meta & MASK_POWERED) == 0)
         {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
             world.setBlockMetadata(x, y, z, meta | MASK_POWERED);
         } else if (!flag){
             world.setBlockMetadata(x, y, z, meta & ~MASK_POWERED);
@@ -121,10 +121,4 @@ public class BlockDispenser extends BlockTileEntityVeryRotatable
         dispenseItem(world, x, y, z, rand);
     }
 
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityDispenser();
-    }
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockDoor.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index 2721ec5a1..2615e2e83 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -8,7 +8,6 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
@@ -16,14 +15,13 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockDoor extends Block implements IPaintable
+public class BlockLogicDoor extends BlockLogic implements IPaintable
 {
     public static final int MASK_ROTATION = 0b0000_0011;
     public static final int MASK_OPENED = 0b0000_0100;
@@ -34,9 +32,9 @@ public class BlockDoor extends Block implements IPaintable
     @Nullable
     public final Supplier<Item> droppedItem;
 	
-	public BlockDoor(String key, String namespaceId, int id, Material material, boolean isTop, boolean requireTool, @Nullable Supplier<Item> droppedItem)
+	public BlockLogicDoor(Block<?> block, Material material, boolean isTop, boolean requireTool, @Nullable Supplier<Item> droppedItem)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         this.isTop = isTop;
         this.requireTool = requireTool;
         this.droppedItem = droppedItem;
@@ -122,20 +120,22 @@ public class BlockDoor extends Block implements IPaintable
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, @Nullable Player player, Side side, double xPlaced, double yPlaced)
     {
-        if(blockMaterial == Material.metal || blockMaterial == Material.steel)
+        if(material == Material.metal || material == Material.steel)
         {
             return false;
         }
         int l = world.getBlockMetadata(x, y, z);
         if(isTop)
         {
-            if(Blocks.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
+            Block<?> b;
+            if((b = Blocks.blocksList[world.getBlockId(x, y - 1, z)]) != null && b.getLogic() instanceof BlockLogicDoor)
             {
             	Blocks.blocksList[world.getBlockId(x, y - 1, z)].onBlockRightClicked(world, x, y - 1, z, player, side, xPlaced, yPlaced);
             }
             return true;
         }
-        if(Blocks.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
+        Block<?> b;
+        if((b = Blocks.blocksList[world.getBlockId(x, y + 1, z)]) != null && b.getLogic() instanceof BlockLogicDoor)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, l ^ MASK_OPENED);
         }
@@ -158,9 +158,10 @@ public class BlockDoor extends Block implements IPaintable
         
         if(isTop)
         {
-            if(Blocks.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
+            Block<?> b;
+            if((b = Blocks.blocksList[world.getBlockId(x, y - 1, z)]) != null && b.getLogic() instanceof BlockLogicDoor)
             {
-            	((BlockDoor)Blocks.blocksList[world.getBlockId(x, y - 1, z)]).onPoweredBlockChange(world, x, y - 1, z, isPowered);
+            	((BlockLogicDoor)b.getLogic()).onPoweredBlockChange(world, x, y - 1, z, isPowered);
             }
             return;
         }
@@ -169,7 +170,8 @@ public class BlockDoor extends Block implements IPaintable
         {
             return;
         }
-        if(Blocks.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
+        Block<?> b;
+        if((b = Blocks.blocksList[world.getBlockId(x, y + 1, z)]) != null && b.getLogic() instanceof BlockLogicDoor)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, meta ^ MASK_OPENED);
         }
@@ -184,20 +186,20 @@ public class BlockDoor extends Block implements IPaintable
 //        int i1 = world.getBlockMetadata(x, y, z);
         if(isTop)
         {
-        	Block otherBlock = Blocks.blocksList[world.getBlockId(x, y - 1, z)];
-            if(!(otherBlock instanceof BlockDoor))
+        	Block<?> otherBlock = Blocks.blocksList[world.getBlockId(x, y - 1, z)];
+            if(!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor))
             {
                 world.setBlockWithNotify(x, y, z, 0);
             }
-            if(blockId > 0 && Blocks.blocksList[blockId].isSignalSource())
+            if(otherBlock != null && blockId > 0 && Blocks.blocksList[blockId].isSignalSource())
             {
                 otherBlock.onNeighborBlockChange(world, x, y - 1, z, blockId);
             }
         } else
         {
             boolean flag = false;
-        	Block otherBlock = Blocks.blocksList[world.getBlockId(x, y + 1, z)];
-            if(!(otherBlock instanceof BlockDoor))
+        	Block<?> otherBlock = Blocks.blocksList[world.getBlockId(x, y + 1, z)];
+            if(!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor))
             {
                 world.setBlockWithNotify(x, y, z, 0);
                 //dropBlockAsItem(world, i, j, k, i1);
@@ -208,7 +210,7 @@ public class BlockDoor extends Block implements IPaintable
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
                 world.setBlockWithNotify(x, y, z, 0);
                 flag = true;
-                if(otherBlock instanceof BlockDoor)
+                if(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor)
                 {
                     world.setBlockWithNotify(x, y + 1, z, 0);
                 }
@@ -235,13 +237,13 @@ public class BlockDoor extends Block implements IPaintable
     	int myMetadata = world.getBlockMetadata(x, y, z);
     	int upId = world.getBlockId(x, y + 1, z);
     	
-    	if (myId == Blocks.DOOR_PLANKS_OAK_BOTTOM.id && upId == Blocks.DOOR_PLANKS_OAK_BOTTOM.id)
+    	if (myId == Blocks.DOOR_PLANKS_OAK_BOTTOM.id() && upId == Blocks.DOOR_PLANKS_OAK_BOTTOM.id())
     	{
-    		world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_PLANKS_OAK_TOP.id, myMetadata);
+    		world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_PLANKS_OAK_TOP.id(), myMetadata);
     	}
-    	else if (myId == Blocks.DOOR_IRON_BOTTOM.id && upId == Blocks.DOOR_IRON_BOTTOM.id)
+    	else if (myId == Blocks.DOOR_IRON_BOTTOM.id() && upId == Blocks.DOOR_IRON_BOTTOM.id())
     	{
-    		world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_IRON_TOP.id, myMetadata);
+    		world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_IRON_TOP.id(), myMetadata);
     	}
     }
 
@@ -299,22 +301,22 @@ public class BlockDoor extends Block implements IPaintable
 
     @Override
     public boolean canBePainted() {
-        return blockMaterial == Material.wood;
+        return material == Material.wood;
     }
 
     @Override
     public void setColor(World world, int x, int y, int z, DyeColor color) {
         final int meta = world.getBlockMetadata(x, y, z);
         if (isTop) {
-            world.setBlockAndMetadata(x, y, z, Blocks.DOOR_PLANKS_PAINTED_TOP.id, meta);
-            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_TOP).setColor(world, x, y, z, color);
-            world.setBlockAndMetadata(x, y - 1, z, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id, meta);
-            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_BOTTOM).setColor(world, x, y - 1, z, color);
+            world.setBlockAndMetadata(x, y, z, Blocks.DOOR_PLANKS_PAINTED_TOP.id(), meta);
+            Blocks.DOOR_PLANKS_PAINTED_TOP.getLogic().setColor(world, x, y, z, color);
+            world.setBlockAndMetadata(x, y - 1, z, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id(), meta);
+            Blocks.DOOR_PLANKS_PAINTED_BOTTOM.getLogic().setColor(world, x, y - 1, z, color);
         } else {
-            world.setBlockAndMetadata(x, y, z, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id, meta);
-            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_BOTTOM).setColor(world, x, y, z, color);
-            world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_PLANKS_PAINTED_TOP.id, meta);
-            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_TOP).setColor(world, x, y + 1, z, color);
+            world.setBlockAndMetadata(x, y, z, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id(), meta);
+            Blocks.DOOR_PLANKS_PAINTED_BOTTOM.getLogic().setColor(world, x, y, z, color);
+            world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_PLANKS_PAINTED_TOP.id(), meta);
+            Blocks.DOOR_PLANKS_PAINTED_TOP.getLogic().setColor(world, x, y + 1, z, color);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
similarity index 81%
rename from game/core/src/main/java/net/minecraft/core/block/BlockDoorPainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
index 08e27fca4..83cd8e844 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
@@ -8,9 +8,9 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
-public class BlockDoorPainted extends BlockDoor implements IPainted {
-    public BlockDoorPainted(String key, String namespaceId, int id, Material material, boolean isTop) {
-        super(key, namespaceId, id, material, isTop, false, null);
+public class BlockLogicDoorPainted extends BlockLogicDoor implements IPainted {
+    public BlockLogicDoorPainted(Block<?> block, Material material, boolean isTop) {
+        super(block, material, isTop, false, null);
     }
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
@@ -36,11 +36,11 @@ public class BlockDoorPainted extends BlockDoor implements IPainted {
     @Override
     public void removeDye(World world, int x, int y, int z) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadataWithNotify(x, y, z, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP.id : Blocks.DOOR_PLANKS_OAK_BOTTOM.id, meta & 0xF);
+        world.setBlockAndMetadataWithNotify(x, y, z, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP.id() : Blocks.DOOR_PLANKS_OAK_BOTTOM.id(), meta & 0xF);
         if (this.isTop) {
-            world.setBlockAndMetadataWithNotify(x, y - 1, z, Blocks.DOOR_PLANKS_OAK_BOTTOM.id, meta & 0xF);
+            world.setBlockAndMetadataWithNotify(x, y - 1, z, Blocks.DOOR_PLANKS_OAK_BOTTOM.id(), meta & 0xF);
         } else {
-            world.setBlockAndMetadataWithNotify(x, y + 1, z, Blocks.DOOR_PLANKS_OAK_TOP.id, meta & 0xF);
+            world.setBlockAndMetadataWithNotify(x, y + 1, z, Blocks.DOOR_PLANKS_OAK_TOP.id(), meta & 0xF);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockEdible.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockEdible.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
index b9eb9c8bf..bbea38fa9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockEdible.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
@@ -12,19 +12,18 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public abstract class BlockEdible extends Block {
+public abstract class BlockLogicEdible extends BlockLogic {
     @NotNull
     private final Supplier<Item> itemSupplier;
     public int maxBites;
     public int healAmount;
 
-    public BlockEdible(String key, String namespaceId, int id, int maxBites, int healAmount, @NotNull Supplier<Item> dropItemSupplier)
+    public BlockLogicEdible(Block<?> block, int maxBites, int healAmount, @NotNull Supplier<Item> dropItemSupplier)
     {
-        super(key, namespaceId, id, Material.cake);
+        super(block, Material.cake);
         this.maxBites = maxBites;
         this.healAmount = healAmount;
         this.itemSupplier = dropItemSupplier;
-        setTicking(true);
     }
 
     @Override
